diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-mlo-test.cc ns-3.38/src/wifi/test/wifi-mlo-test.cc
--- ns-3.37/src/wifi/test/wifi-mlo-test.cc	2022-11-01 17:37:24.763395800 -0700
+++ ns-3.38/src/wifi/test/wifi-mlo-test.cc	2023-03-16 20:54:23.872869300 -0700
@@ -757,31 +954,1540 @@
         if (it == m_setupLinks.end())
         {
             // the link has not been setup
-            NS_TEST_EXPECT_MSG_EQ(m_staMac->GetWifiPhy(linkId)->GetState()->IsStateOff(),
+            NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetWifiPhy(linkId)->GetState()->IsStateOff(),
                                   true,
                                   "Link " << +linkId << " has not been setup but is not disabled");
             continue;
         }
 
-        if (GetPhyBandFromChannelStr(m_staChannels.at(it->first)) !=
-            GetPhyBandFromChannelStr(m_apChannels.at(it->second)))
+        // the link has been setup and must be active
+        NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetWifiPhy(linkId)->GetState()->IsStateOff(),
+                              false,
+                              "Expecting link " << +linkId << " to be active");
+    }
+}
+
+/**
+ * Tested traffic patterns.
+ */
+enum class WifiTrafficPattern : uint8_t
+{
+    STA_TO_STA = 0,
+    STA_TO_AP,
+    AP_TO_STA,
+    AP_TO_BCAST,
+    STA_TO_BCAST
+};
+
+/**
+ * Block Ack agreement enabled/disabled
+ */
+enum class WifiBaEnabled : uint8_t
+{
+    NO = 0,
+    YES
+};
+
+/**
+ * Whether to send a BlockAckReq after a missed BlockAck
+ */
+enum class WifiUseBarAfterMissedBa : uint8_t
+{
+    NO = 0,
+    YES
+};
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Test data transmission between two MLDs.
+ *
+ * This test sets up an AP MLD and two non-AP MLDs having a variable number of links.
+ * The RF channels to set each link to are provided as input parameters through the test
+ * case constructor, along with the identifiers (starting at 0) of the links that cannot
+ * switch PHY band (if any). This test aims at veryfing the successful transmission of both
+ * unicast QoS data frames (from one station to another, from one station to the AP, from
+ * the AP to the station) and broadcast QoS data frames (from the AP or from one station).
+ * In the scenarios in which the AP forwards frames (i.e., from one station to another and
+ * from one station to broadcast) the client application generates only 4 packets, in order
+ * to limit the probability of collisions. In the other scenarios, 8 packets are generated.
+ * When BlockAck agreements are enabled, the maximum A-MSDU size is set such that two
+ * packets can be aggregated in an A-MSDU. The MPDU with sequence number equal to 1 is
+ * corrupted (once, by using a post reception error model) to test its successful
+ * re-transmission, unless the traffic scenario is from the AP to broadcast (broadcast frames
+ * are not retransmitted) or is a scenario where the AP forwards frame (to limit the
+ * probability of collisions).
+ *
+ * When BlockAck agreements are enabled, we also corrupt a BlockAck frame, so as to simulate
+ * the case of BlockAck timeout. Both the case where a BlockAckReq is sent and the case where
+ * data frame are retransmitted are tested. Finally, when BlockAck agreements are enabled, we
+ * also enable the concurrent transmission of data frames over two links and check that at
+ * least one MPDU is concurrently transmitted over two links.
+ */
+class MultiLinkTxTest : public MultiLinkOperationsTestBase
+{
+  public:
+    /**
+     * Constructor
+     *
+     * \param trafficPattern the pattern of traffic to generate
+     * \param baEnabled whether BA agreement is enabled or disabled
+     * \param useBarAfterMissedBa whether a BAR or Data frames are sent after missed BlockAck
+     * \param nMaxInflight the max number of links on which an MPDU can be simultaneously inflight
+     *                     (unused if Block Ack agreements are not established)
+     * \param staChannels the strings specifying the operating channels for the STA
+     * \param apChannels the strings specifying the operating channels for the AP
+     * \param fixedPhyBands list of IDs of STA links that cannot switch PHY band
+     */
+    MultiLinkTxTest(WifiTrafficPattern trafficPattern,
+                    WifiBaEnabled baEnabled,
+                    WifiUseBarAfterMissedBa useBarAfterMissedBa,
+                    uint8_t nMaxInflight,
+                    const std::vector<std::string>& staChannels,
+                    const std::vector<std::string>& apChannels,
+                    const std::vector<uint8_t>& fixedPhyBands = {});
+    ~MultiLinkTxTest() override = default;
+
+  protected:
+    /**
+     * Function to trace packets received by the server application
+     * \param nodeId the ID of the node that received the packet
+     * \param p the packet
+     * \param addr the address
+     */
+    void L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr);
+
+    /**
+     * Check the content of a received BlockAck frame when the max number of links on which
+     * an MPDU can be inflight is one.
+     *
+     * \param psdu the PSDU containing the BlockAck
+     * \param txVector the TXVECTOR used to transmit the BlockAck
+     * \param linkId the ID of the link on which the BlockAck was transmitted
+     */
+    void CheckBlockAck(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId);
+
+    void Transmit(uint8_t linkId,
+                  std::string context,
+                  WifiConstPsduMap psduMap,
+                  WifiTxVector txVector,
+                  double txPowerW) override;
+    void DoSetup() override;
+    void DoRun() override;
+
+  private:
+    void StartTraffic() override;
+
+    /// Receiver address-indexed map of list error models
+    using RxErrorModelMap = std::unordered_map<Mac48Address, Ptr<ListErrorModel>, WifiAddressHash>;
+
+    RxErrorModelMap m_errorModels;         ///< error rate models to corrupt packets
+    std::list<uint64_t> m_uidList;         ///< list of UIDs of packets to corrupt
+    bool m_dataCorrupted{false};           ///< whether second data frame has been already corrupted
+    WifiTrafficPattern m_trafficPattern;   ///< the pattern of traffic to generate
+    bool m_baEnabled;                      ///< whether BA agreement is enabled or disabled
+    bool m_useBarAfterMissedBa;            ///< whether to send BAR after missed BlockAck
+    std::size_t m_nMaxInflight;            ///< max number of links on which an MPDU can be inflight
+    std::size_t m_nPackets;                ///< number of application packets to generate
+    std::size_t m_blockAckCount{0};        ///< transmitted BlockAck counter
+    std::size_t m_blockAckReqCount{0};     ///< transmitted BlockAckReq counter
+    std::array<std::size_t, 3> m_rxPkts{}; ///< number of packets received at application layer
+                                           ///< by each node (AP, STA 0, STA 1)
+    std::map<uint16_t, std::size_t> m_inflightCount; ///< seqNo-indexed max number of simultaneous
+                                                     ///< transmissions of a data frame
+    Ptr<WifiMac> m_sourceMac; ///< MAC of the node sending application packets
+};
+
+MultiLinkTxTest::MultiLinkTxTest(WifiTrafficPattern trafficPattern,
+                                 WifiBaEnabled baEnabled,
+                                 WifiUseBarAfterMissedBa useBarAfterMissedBa,
+                                 uint8_t nMaxInflight,
+                                 const std::vector<std::string>& staChannels,
+                                 const std::vector<std::string>& apChannels,
+                                 const std::vector<uint8_t>& fixedPhyBands)
+    : MultiLinkOperationsTestBase(
+          std::string("Check data transmission between MLDs ") +
+              (baEnabled == WifiBaEnabled::YES
+                   ? (useBarAfterMissedBa == WifiUseBarAfterMissedBa::YES
+                          ? "with BA agreement, send BAR after BlockAck timeout"
+                          : "with BA agreement, send Data frames after BlockAck timeout")
+                   : "without BA agreement") +
+              " (Traffic pattern: " + std::to_string(static_cast<uint8_t>(trafficPattern)) +
+              (baEnabled == WifiBaEnabled::YES ? ", nMaxInflight=" + std::to_string(nMaxInflight)
+                                               : "") +
+              ")",
+          2,
+          staChannels,
+          apChannels,
+          fixedPhyBands),
+      m_trafficPattern(trafficPattern),
+      m_baEnabled(baEnabled == WifiBaEnabled::YES),
+      m_useBarAfterMissedBa(useBarAfterMissedBa == WifiUseBarAfterMissedBa::YES),
+      m_nMaxInflight(nMaxInflight),
+      m_nPackets(trafficPattern == WifiTrafficPattern::STA_TO_BCAST ||
+                         trafficPattern == WifiTrafficPattern::STA_TO_STA
+                     ? 4
+                     : 8)
+{
+}
+
+void
+MultiLinkTxTest::Transmit(uint8_t linkId,
+                          std::string context,
+                          WifiConstPsduMap psduMap,
+                          WifiTxVector txVector,
+                          double txPowerW)
+{
+    auto psdu = psduMap.begin()->second;
+
+    switch (psdu->GetHeader(0).GetType())
+    {
+    case WIFI_MAC_MGT_ACTION:
+        // a management frame is a DL frame if TA equals BSSID
+        CheckAddresses(psdu,
+                       psdu->GetHeader(0).GetAddr2() == psdu->GetHeader(0).GetAddr3() ? DL : UL);
+        if (!m_baEnabled)
+        {
+            // corrupt all management action frames (ADDBA Request frames) to prevent
+            // the establishment of a BA agreement
+            m_uidList.push_front(psdu->GetPacket()->GetUid());
+            m_errorModels.at(psdu->GetAddr1())->SetList(m_uidList);
+            NS_LOG_INFO("CORRUPTED");
+        }
+        break;
+    case WIFI_MAC_QOSDATA:
+        CheckAddresses(psdu);
+
+        for (const auto& mpdu : *psdu)
+        {
+            // determine the max number of simultaneous transmissions for this MPDU
+            // (only if sent by the traffic source and this is not a broadcast frame)
+            if (m_baEnabled && linkId < m_sourceMac->GetNLinks() &&
+                m_sourceMac->GetFrameExchangeManager(linkId)->GetAddress() ==
+                    mpdu->GetHeader().GetAddr2() &&
+                !mpdu->GetHeader().GetAddr1().IsGroup())
+            {
+                auto seqNo = mpdu->GetHeader().GetSequenceNumber();
+                auto [it, success] =
+                    m_inflightCount.insert({seqNo, mpdu->GetInFlightLinkIds().size()});
+                if (!success)
+                {
+                    it->second = std::max(it->second, mpdu->GetInFlightLinkIds().size());
+                }
+            }
+        }
+        for (std::size_t i = 0; i < psdu->GetNMpdus(); i++)
+        {
+            // corrupt QoS data frame with sequence number equal to 1 (only once) if we are
+            // not in the AP to broadcast traffic pattern (broadcast frames are not retransmitted)
+            // nor in the STA to broadcast or STA to STA traffic patterns (retransmissions from
+            // STA 1 could collide with frames forwarded by the AP)
+            if (psdu->GetHeader(i).GetSequenceNumber() != 1 ||
+                m_trafficPattern == WifiTrafficPattern::AP_TO_BCAST ||
+                m_trafficPattern == WifiTrafficPattern::STA_TO_BCAST ||
+                m_trafficPattern == WifiTrafficPattern::STA_TO_STA)
+            {
+                continue;
+            }
+            auto uid = psdu->GetPayload(i)->GetUid();
+            if (!m_dataCorrupted)
+            {
+                m_uidList.push_front(uid);
+                m_dataCorrupted = true;
+                NS_LOG_INFO("CORRUPTED");
+                m_errorModels.at(psdu->GetAddr1())->SetList(m_uidList);
+            }
+            else
+            {
+                // do not corrupt the QoS data frame anymore
+                if (auto it = std::find(m_uidList.cbegin(), m_uidList.cend(), uid);
+                    it != m_uidList.cend())
+                {
+                    m_uidList.erase(it);
+                }
+                m_errorModels.at(psdu->GetAddr1())->SetList(m_uidList);
+            }
+            break;
+        }
+        break;
+    case WIFI_MAC_CTL_BACKRESP: {
+        // ignore BlockAck frames not addressed to the source of the application packets
+        if (!m_sourceMac->GetLinkIdByAddress(psdu->GetHeader(0).GetAddr1()))
+        {
+            break;
+        }
+        if (m_nMaxInflight > 1)
+        {
+            // we do not check the content of BlockAck when m_nMaxInflight is greater than 1
+            break;
+        }
+        CheckBlockAck(psdu, txVector, linkId);
+        m_blockAckCount++;
+        if (m_blockAckCount == 2)
+        {
+            // corrupt the second BlockAck frame to simulate a missed BlockAck
+            m_uidList.push_front(psdu->GetPacket()->GetUid());
+            NS_LOG_INFO("CORRUPTED");
+            m_errorModels.at(psdu->GetAddr1())->SetList(m_uidList);
+        }
+        break;
+    case WIFI_MAC_CTL_BACKREQ:
+        // ignore BlockAckReq frames not transmitted by the source of the application packets
+        if (m_sourceMac->GetLinkIdByAddress(psdu->GetHeader(0).GetAddr2()))
+        {
+            m_blockAckReqCount++;
+        }
+        break;
+    }
+    default:;
+    }
+
+    MultiLinkOperationsTestBase::Transmit(linkId, context, psduMap, txVector, txPowerW);
+}
+
+void
+MultiLinkTxTest::CheckBlockAck(Ptr<const WifiPsdu> psdu,
+                               const WifiTxVector& txVector,
+                               uint8_t linkId)
+{
+    NS_TEST_ASSERT_MSG_EQ(m_baEnabled, true, "No BlockAck expected without BA agreement");
+    NS_TEST_ASSERT_MSG_EQ((m_trafficPattern != WifiTrafficPattern::AP_TO_BCAST),
+                          true,
+                          "No BlockAck expected in AP to broadcast traffic pattern");
+
+    /*
+     *         ┌───────┬───────X        ┌───────┐
+     *  link 0 │   0   │   1   │        │   1   │
+     *  ───────┴───────┴───────┴┬──┬────┴───────┴┬───┬────────────────────────
+     *                          │BA│             │ACK│
+     *                          └──┘             └───┘
+     *                      ┌───────┬───────┐       ┌───────┬───────┐
+     *  link 1              │   2   │   3   │       │   2   │   3   │
+     *  ────────────────────┴───────┴───────┴┬──X───┴───────┴───────┴┬──┬─────
+     *                                       │BA│                    │BA│
+     *                                       └──┘                    └──┘
+     */
+    auto mpdu = *psdu->begin();
+    CtrlBAckResponseHeader blockAck;
+    mpdu->GetPacket()->PeekHeader(blockAck);
+    bool isMpdu1corrupted = (m_trafficPattern == WifiTrafficPattern::STA_TO_AP ||
+                             m_trafficPattern == WifiTrafficPattern::AP_TO_STA);
+
+    switch (m_blockAckCount)
+    {
+    case 0: // first BlockAck frame (all traffic patterns)
+        NS_TEST_EXPECT_MSG_EQ(blockAck.IsPacketReceived(0),
+                              true,
+                              "MPDU 0 expected to be successfully received");
+        NS_TEST_EXPECT_MSG_EQ(
+            blockAck.IsPacketReceived(1),
+            !isMpdu1corrupted,
+            "MPDU 1 expected to be received only in STA_TO_STA/STA_TO_BCAST scenarios");
+        // if there are at least two links setup, we expect all MPDUs to be inflight
+        // (on distinct links)
+        if (m_staMacs[0]->GetSetupLinkIds().size() > 1)
+        {
+            auto queue = m_sourceMac->GetTxopQueue(AC_BE);
+            auto rcvMac = m_sourceMac == m_staMacs[0] ? StaticCast<WifiMac>(m_apMac)
+                                                      : StaticCast<WifiMac>(m_staMacs[1]);
+            auto item = queue->PeekByTidAndAddress(0, rcvMac->GetAddress());
+            std::size_t nQueuedPkt = 0;
+            auto delay = WifiPhy::CalculateTxDuration(psdu,
+                                                      txVector,
+                                                      rcvMac->GetWifiPhy(linkId)->GetPhyBand()) +
+                         MicroSeconds(1); // to account for propagation delay
+
+            while (item)
+            {
+                auto seqNo = item->GetHeader().GetSequenceNumber();
+                NS_TEST_EXPECT_MSG_EQ(item->IsInFlight(),
+                                      true,
+                                      "MPDU with seqNo=" << seqNo << " is not in flight");
+                auto linkIds = item->GetInFlightLinkIds();
+                NS_TEST_EXPECT_MSG_EQ(linkIds.size(),
+                                      1,
+                                      "MPDU with seqNo=" << seqNo
+                                                         << " is in flight on multiple links");
+                // The first two MPDUs are in flight on the same link on which the BlockAck
+                // is sent. The other two MPDUs (only for AP to STA/STA to AP scenarios) are
+                // in flight on a different link.
+                auto srcLinkId = m_sourceMac->GetLinkIdByAddress(mpdu->GetHeader().GetAddr1());
+                NS_TEST_ASSERT_MSG_EQ(srcLinkId.has_value(),
+                                      true,
+                                      "Addr1 of BlockAck is not an originator's link address");
+                NS_TEST_EXPECT_MSG_EQ((*linkIds.begin() == *srcLinkId),
+                                      (seqNo <= 1),
+                                      "MPDU with seqNo=" << seqNo
+                                                         << " in flight on unexpected link");
+                // check the Retry subfield and whether this MPDU is still queued
+                // after the originator has processed this BlockAck
+
+                // MPDUs acknowledged via this BlockAck are no longer queued
+                bool isQueued = (seqNo > (isMpdu1corrupted ? 0 : 1));
+                // The Retry subfield is set if the MPDU has not been acknowledged (i.e., it
+                // is still queued) and has been transmitted on the same link as the BlockAck
+                // (i.e., its sequence number is less than or equal to 1)
+                bool isRetry = isQueued && seqNo <= 1;
+
+                Simulator::Schedule(delay, [this, item, isQueued, isRetry]() {
+                    NS_TEST_EXPECT_MSG_EQ(item->IsQueued(),
+                                          isQueued,
+                                          "MPDU with seqNo="
+                                              << item->GetHeader().GetSequenceNumber() << " should "
+                                              << (isQueued ? "" : "not") << " be queued");
+                    NS_TEST_EXPECT_MSG_EQ(
+                        item->GetHeader().IsRetry(),
+                        isRetry,
+                        "Unexpected value for the Retry subfield of the MPDU with seqNo="
+                            << item->GetHeader().GetSequenceNumber());
+                });
+
+                nQueuedPkt++;
+                item = queue->PeekByTidAndAddress(0, rcvMac->GetAddress(), item);
+            }
+            // Each MPDU contains an A-MSDU consisting of two MSDUs
+            NS_TEST_EXPECT_MSG_EQ(nQueuedPkt, m_nPackets / 2, "Unexpected number of queued MPDUs");
+        }
+        break;
+    case 1: // second BlockAck frame (STA to AP and AP to STA traffic patterns only)
+    case 2: // third BlockAck frame (STA to AP and AP to STA traffic patterns only)
+        NS_TEST_EXPECT_MSG_EQ((m_trafficPattern == WifiTrafficPattern::AP_TO_STA ||
+                               m_trafficPattern == WifiTrafficPattern::STA_TO_AP),
+                              true,
+                              "Did not expect to receive a second BlockAck");
+        // the second BlockAck is corrupted, but the data frames have been received successfully
+        std::pair<uint16_t, uint16_t> seqNos;
+        // if multiple links were setup, the transmission of the second A-MPDU started before
+        // the end of the first one, so the second A-MPDU includes MPDUs with sequence numbers
+        // 2 and 3. Otherwise, MPDU with sequence number 1 is retransmitted along with the MPDU
+        // with sequence number 2.
+        if (m_staMacs[0]->GetSetupLinkIds().size() > 1)
+        {
+            seqNos = {2, 3};
+        }
+        else
+        {
+            seqNos = {1, 2};
+        }
+        NS_TEST_EXPECT_MSG_EQ(blockAck.IsPacketReceived(seqNos.first),
+                              true,
+                              "MPDU " << seqNos.first << " expected to be successfully received");
+        NS_TEST_EXPECT_MSG_EQ(blockAck.IsPacketReceived(seqNos.second),
+                              true,
+                              "MPDU " << seqNos.second << " expected to be successfully received");
+        break;
+    }
+}
+
+void
+MultiLinkTxTest::L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr)
+{
+    NS_LOG_INFO("Packet received by NODE " << +nodeId << "\n");
+    m_rxPkts[nodeId]++;
+}
+
+void
+MultiLinkTxTest::DoSetup()
+{
+    MultiLinkOperationsTestBase::DoSetup();
+
+    if (m_baEnabled)
+    {
+        // Enable A-MSDU aggregation. Max A-MSDU size is set such that two MSDUs can be aggregated
+        for (auto mac : std::initializer_list<Ptr<WifiMac>>{m_apMac, m_staMacs[0], m_staMacs[1]})
+        {
+            mac->SetAttribute("BE_MaxAmsduSize", UintegerValue(2100));
+            mac->GetQosTxop(AC_BE)->SetAttribute("UseExplicitBarAfterMissedBlockAck",
+                                                 BooleanValue(m_useBarAfterMissedBa));
+            mac->GetQosTxop(AC_BE)->SetAttribute("NMaxInflights", UintegerValue(m_nMaxInflight));
+        }
+    }
+
+    // install post reception error model on all devices
+    for (std::size_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
+    {
+        auto errorModel = CreateObject<ListErrorModel>();
+        m_errorModels[m_apMac->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
+        m_apMac->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+    }
+    for (std::size_t linkId = 0; linkId < m_staMacs[0]->GetNLinks(); linkId++)
+    {
+        auto errorModel = CreateObject<ListErrorModel>();
+        m_errorModels[m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
+        m_staMacs[0]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+
+        errorModel = CreateObject<ListErrorModel>();
+        m_errorModels[m_staMacs[1]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
+        m_staMacs[1]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+    }
+}
+
+void
+MultiLinkTxTest::StartTraffic()
+{
+    const Time duration = Seconds(1);
+    Address destAddr;
+
+    switch (m_trafficPattern)
+    {
+    case WifiTrafficPattern::STA_TO_STA:
+        m_sourceMac = m_staMacs[0];
+        destAddr = m_staMacs[1]->GetDevice()->GetAddress();
+        break;
+    case WifiTrafficPattern::STA_TO_AP:
+        m_sourceMac = m_staMacs[0];
+        destAddr = m_apMac->GetDevice()->GetAddress();
+        break;
+    case WifiTrafficPattern::AP_TO_STA:
+        m_sourceMac = m_apMac;
+        destAddr = m_staMacs[1]->GetDevice()->GetAddress();
+        break;
+    case WifiTrafficPattern::AP_TO_BCAST:
+        m_sourceMac = m_apMac;
+        destAddr = Mac48Address::GetBroadcast();
+        break;
+    case WifiTrafficPattern::STA_TO_BCAST:
+        m_sourceMac = m_staMacs[0];
+        destAddr = Mac48Address::GetBroadcast();
+        break;
+    }
+
+    PacketSocketHelper packetSocket;
+    packetSocket.Install(m_apMac->GetDevice()->GetNode());
+    packetSocket.Install(m_staMacs[0]->GetDevice()->GetNode());
+    packetSocket.Install(m_staMacs[1]->GetDevice()->GetNode());
+
+    PacketSocketAddress socket;
+    socket.SetSingleDevice(m_sourceMac->GetDevice()->GetIfIndex());
+    socket.SetPhysicalAddress(destAddr);
+    socket.SetProtocol(1);
+
+    // install first client application generating at most 4 packets
+    auto client1 = CreateObject<PacketSocketClient>();
+    client1->SetAttribute("PacketSize", UintegerValue(1000));
+    client1->SetAttribute("MaxPackets", UintegerValue(std::min<std::size_t>(m_nPackets, 4)));
+    client1->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+    client1->SetRemote(socket);
+    m_sourceMac->GetDevice()->GetNode()->AddApplication(client1);
+    client1->SetStartTime(Seconds(0)); // now
+    client1->SetStopTime(duration);
+
+    if (m_nPackets > 4)
+    {
+        // install a second client application generating the remaining packets
+        auto client2 = CreateObject<PacketSocketClient>();
+        client2->SetAttribute("PacketSize", UintegerValue(1000));
+        client2->SetAttribute("MaxPackets", UintegerValue(m_nPackets - 4));
+        client2->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+        client2->SetRemote(socket);
+        m_sourceMac->GetDevice()->GetNode()->AddApplication(client2);
+        // start during transmission of first A-MPDU, if multiple links are setup
+        client2->SetStartTime(MilliSeconds(3));
+        client2->SetStopTime(duration);
+    }
+
+    // install a server on all nodes
+    for (auto nodeIt = NodeList::Begin(); nodeIt != NodeList::End(); nodeIt++)
+    {
+        Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
+        server->SetLocal(socket);
+        (*nodeIt)->AddApplication(server);
+        server->SetStartTime(Seconds(0)); // now
+        server->SetStopTime(duration);
+    }
+
+    for (std::size_t nodeId = 0; nodeId < NodeList::GetNNodes(); nodeId++)
+    {
+        Config::ConnectWithoutContext("/NodeList/" + std::to_string(nodeId) +
+                                          "/ApplicationList/*/$ns3::PacketSocketServer/Rx",
+                                      MakeCallback(&MultiLinkTxTest::L7Receive, this).Bind(nodeId));
+    }
+
+    Simulator::Stop(duration);
+}
+
+void
+MultiLinkTxTest::DoRun()
+{
+    Simulator::Run();
+
+    // Expected number of packets received by each node (AP, STA 0, STA 1) at application layer
+    std::array<std::size_t, 3> expectedRxPkts{};
+
+    switch (m_trafficPattern)
+    {
+    case WifiTrafficPattern::STA_TO_STA:
+    case WifiTrafficPattern::AP_TO_STA:
+        // only STA 1 receives the m_nPackets packets that have been transmitted
+        expectedRxPkts[2] = m_nPackets;
+        break;
+    case WifiTrafficPattern::STA_TO_AP:
+        // only the AP receives the m_nPackets packets that have been transmitted
+        expectedRxPkts[0] = m_nPackets;
+        break;
+    case WifiTrafficPattern::AP_TO_BCAST:
+        // the AP replicates the broadcast frames on all the links, hence each station
+        // receives the m_nPackets packets N times, where N is the number of setup link
+        expectedRxPkts[1] = m_nPackets * m_staMacs[0]->GetSetupLinkIds().size();
+        expectedRxPkts[2] = m_nPackets * m_staMacs[1]->GetSetupLinkIds().size();
+        break;
+    case WifiTrafficPattern::STA_TO_BCAST:
+        // the AP receives the m_nPackets packets and then replicates them on all the links,
+        // hence STA 1 receives m_nPackets packets N times, where N is the number of setup link
+        expectedRxPkts[0] = m_nPackets;
+        expectedRxPkts[2] = m_nPackets * m_staMacs[1]->GetSetupLinkIds().size();
+        break;
+    }
+
+    NS_TEST_EXPECT_MSG_EQ(+m_rxPkts[0],
+                          +expectedRxPkts[0],
+                          "Unexpected number of packets received by the AP");
+    NS_TEST_EXPECT_MSG_EQ(+m_rxPkts[1],
+                          +expectedRxPkts[1],
+                          "Unexpected number of packets received by STA 0");
+    NS_TEST_EXPECT_MSG_EQ(+m_rxPkts[2],
+                          +expectedRxPkts[2],
+                          "Unexpected number of packets received by STA 1");
+
+    // check that the expected number of BlockAck frames are transmitted
+    if (m_baEnabled && m_nMaxInflight == 1)
+    {
+        std::size_t expectedBaCount = 0;
+        std::size_t expectedBarCount = 0;
+
+        switch (m_trafficPattern)
+        {
+        case WifiTrafficPattern::STA_TO_AP:
+        case WifiTrafficPattern::AP_TO_STA:
+            // two A-MPDUs are transmitted and one BlockAck is corrupted
+            expectedBaCount = 3;
+            // one BlockAckReq is sent if m_useBarAfterMissedBa is true
+            expectedBarCount = m_useBarAfterMissedBa ? 1 : 0;
+            break;
+        case WifiTrafficPattern::STA_TO_STA:
+        case WifiTrafficPattern::STA_TO_BCAST:
+            // only one A-MPDU is transmitted and the BlockAck is not corrupted
+            expectedBaCount = 1;
+            break;
+        default:;
+        }
+        NS_TEST_EXPECT_MSG_EQ(m_blockAckCount,
+                              expectedBaCount,
+                              "Unexpected number of BlockAck frames");
+        NS_TEST_EXPECT_MSG_EQ(m_blockAckReqCount,
+                              expectedBarCount,
+                              "Unexpected number of BlockAckReq frames");
+    }
+
+    // check that setting the QosTxop::NMaxInflights attribute has the expected effect.
+    // We do not support sending an MPDU multiple times concurrently without Block Ack
+    // agreement. Also, broadcast frames are already duplicated and sent on all links.
+    if (m_baEnabled && m_trafficPattern != WifiTrafficPattern::AP_TO_BCAST)
+    {
+        NS_TEST_EXPECT_MSG_EQ(
+            m_inflightCount.size(),
+            m_nPackets / 2,
+            "Did not collect number of simultaneous transmissions for all data frames");
+
+        auto nMaxInflight = std::min(m_nMaxInflight, m_staMacs[0]->GetSetupLinkIds().size());
+        std::size_t maxCount = 0;
+        for (const auto& [seqNo, count] : m_inflightCount)
+        {
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(
+                count,
+                nMaxInflight,
+                "MPDU with seqNo=" << seqNo
+                                   << " transmitted simultaneously more times than allowed");
+            maxCount = std::max(maxCount, count);
+        }
+
+        NS_TEST_EXPECT_MSG_EQ(
+            maxCount,
+            nMaxInflight,
+            "Expected that at least one data frame was transmitted simultaneously a number of "
+            "times equal to the NMaxInflights attribute");
+    }
+
+    Simulator::Destroy();
+}
+
+/**
+ * Tested MU traffic patterns.
+ */
+enum class WifiMuTrafficPattern : uint8_t
+{
+    DL_MU_BAR_BA_SEQUENCE = 0,
+    DL_MU_MU_BAR,
+    DL_MU_AGGR_MU_BAR,
+    UL_MU
+};
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Test data transmission between MLDs using OFDMA MU transmissions
+ *
+ * This test sets up an AP MLD and two non-AP MLDs having a variable number of links.
+ * The RF channels to set each link to are provided as input parameters through the test
+ * case constructor, along with the identifiers (starting at 0) of the links that cannot
+ * switch PHY band (if any). This test aims at veryfing the successful transmission of both
+ * DL MU and UL MU frames. In the DL MU scenarios, the client applications installed on the
+ * AP generate 8 packets addressed to each of the stations (plus 3 packets to trigger the
+ * establishment of BlockAck agreements). In the UL MU scenario, client applications
+ * installed on the stations generate 4 packets each (plus 3 packets to trigger the
+ * establishment of BlockAck agreements).
+ *
+ * The maximum A-MSDU size is set such that two packets can be aggregated in an A-MSDU.
+ * The MPDU with sequence number equal to 3 is corrupted (by using a post reception error
+ * model) once and for a single station, to test its successful re-transmission.
+ *
+ * Also, we enable the concurrent transmission of data frames over two links and check that at
+ * least one MPDU is concurrently transmitted over two links.
+ */
+class MultiLinkMuTxTest : public MultiLinkOperationsTestBase
+{
+  public:
+    /**
+     * Constructor
+     *
+     * \param muTrafficPattern the pattern of traffic to generate
+     * \param useBarAfterMissedBa whether a BAR or Data frames are sent after missed BlockAck
+     * \param nMaxInflight the max number of links on which an MPDU can be simultaneously inflight
+     *                     (unused if Block Ack agreements are not established)
+     * \param staChannels the strings specifying the operating channels for the STA
+     * \param apChannels the strings specifying the operating channels for the AP
+     * \param fixedPhyBands list of IDs of STA links that cannot switch PHY band
+     */
+    MultiLinkMuTxTest(WifiMuTrafficPattern muTrafficPattern,
+                      WifiUseBarAfterMissedBa useBarAfterMissedBa,
+                      uint8_t nMaxInflight,
+                      const std::vector<std::string>& staChannels,
+                      const std::vector<std::string>& apChannels,
+                      const std::vector<uint8_t>& fixedPhyBands = {});
+    ~MultiLinkMuTxTest() override = default;
+
+  protected:
+    /**
+     * Function to trace packets received by the server application
+     * \param nodeId the ID of the node that received the packet
+     * \param p the packet
+     * \param addr the address
+     */
+    void L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr);
+
+    /**
+     * Check the content of a received BlockAck frame when the max number of links on which
+     * an MPDU can be inflight is one.
+     *
+     * \param psdu the PSDU containing the BlockAck
+     * \param txVector the TXVECTOR used to transmit the BlockAck
+     * \param linkId the ID of the link on which the BlockAck was transmitted
+     */
+    void CheckBlockAck(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId);
+
+    void Transmit(uint8_t linkId,
+                  std::string context,
+                  WifiConstPsduMap psduMap,
+                  WifiTxVector txVector,
+                  double txPowerW) override;
+    void DoSetup() override;
+    void DoRun() override;
+
+  private:
+    void StartTraffic() override;
+
+    /// Receiver address-indexed map of list error models
+    using RxErrorModelMap = std::unordered_map<Mac48Address, Ptr<ListErrorModel>, WifiAddressHash>;
+
+    /// A pair of a MAC address (the address of the receiver for DL frames and the address of
+    /// the sender for UL frames) and a sequence number identifying a transmitted QoS data frame
+    using AddrSeqNoPair = std::pair<Mac48Address, uint16_t>;
+
+    RxErrorModelMap m_errorModels;                  ///< error rate models to corrupt packets
+    std::list<uint64_t> m_uidList;                  ///< list of UIDs of packets to corrupt
+    std::optional<Mac48Address> m_dataCorruptedSta; ///< MAC address of the station that received
+                                                    ///< MPDU with SeqNo=2 corrupted
+    bool m_waitFirstTf{true}; ///< whether we are waiting for the first Basic Trigger Frame
+    WifiMuTrafficPattern m_muTrafficPattern; ///< the pattern of traffic to generate
+    bool m_useBarAfterMissedBa;              ///< whether to send BAR after missed BlockAck
+    std::size_t m_nMaxInflight; ///< max number of links on which an MPDU can be inflight
+    std::vector<PacketSocketAddress> m_sockets; ///< packet socket addresses for STAs
+    std::size_t m_nPackets;                     ///< number of application packets to generate
+    std::size_t m_blockAckCount{0};             ///< transmitted BlockAck counter
+    // std::size_t m_blockAckReqCount{0};     ///< transmitted BlockAckReq counter
+    std::array<std::size_t, 3> m_rxPkts{}; ///< number of packets received at application layer
+                                           ///< by each node (AP, STA 0, STA 1)
+    std::map<AddrSeqNoPair, std::size_t> m_inflightCount; ///< max number of simultaneous
+                                                          ///< transmissions of each data frame
+    Ptr<WifiMac> m_sourceMac; ///< MAC of the node sending application packets
+};
+
+MultiLinkMuTxTest::MultiLinkMuTxTest(WifiMuTrafficPattern muTrafficPattern,
+                                     WifiUseBarAfterMissedBa useBarAfterMissedBa,
+                                     uint8_t nMaxInflight,
+                                     const std::vector<std::string>& staChannels,
+                                     const std::vector<std::string>& apChannels,
+                                     const std::vector<uint8_t>& fixedPhyBands)
+    : MultiLinkOperationsTestBase(
+          std::string("Check MU data transmission between MLDs ") +
+              (useBarAfterMissedBa == WifiUseBarAfterMissedBa::YES
+                   ? "(send BAR after BlockAck timeout,"
+                   : "(send Data frames after BlockAck timeout,") +
+              " MU Traffic pattern: " + std::to_string(static_cast<uint8_t>(muTrafficPattern)) +
+              ", nMaxInflight=" + std::to_string(nMaxInflight) + ")",
+          2,
+          staChannels,
+          apChannels,
+          fixedPhyBands),
+      m_muTrafficPattern(muTrafficPattern),
+      m_useBarAfterMissedBa(useBarAfterMissedBa == WifiUseBarAfterMissedBa::YES),
+      m_nMaxInflight(nMaxInflight),
+      m_sockets(m_nStations),
+      m_nPackets(muTrafficPattern == WifiMuTrafficPattern::UL_MU ? 4 : 8)
+{
+}
+
+void
+MultiLinkMuTxTest::Transmit(uint8_t linkId,
+                            std::string context,
+                            WifiConstPsduMap psduMap,
+                            WifiTxVector txVector,
+                            double txPowerW)
+{
+    CtrlTriggerHeader trigger;
+
+    for (const auto& [staId, psdu] : psduMap)
+    {
+        switch (psdu->GetHeader(0).GetType())
+        {
+        case WIFI_MAC_QOSDATA:
+            CheckAddresses(psdu);
+            if (psdu->GetHeader(0).HasData())
+            {
+                bool isDl = psdu->GetHeader(0).IsFromDs();
+                auto linkAddress =
+                    isDl ? psdu->GetHeader(0).GetAddr1() : psdu->GetHeader(0).GetAddr2();
+                auto address = m_apMac->GetMldAddress(linkAddress).value_or(linkAddress);
+
+                for (const auto& mpdu : *psdu)
+                {
+                    // determine the max number of simultaneous transmissions for this MPDU
+                    auto seqNo = mpdu->GetHeader().GetSequenceNumber();
+                    auto [it, success] = m_inflightCount.insert(
+                        {{address, seqNo}, mpdu->GetInFlightLinkIds().size()});
+                    if (!success)
+                    {
+                        it->second = std::max(it->second, mpdu->GetInFlightLinkIds().size());
+                    }
+                }
+                for (std::size_t i = 0; i < psdu->GetNMpdus(); i++)
+                {
+                    // MPDUs with seqNo=2 are always transmitted in an MU PPDU
+                    if (psdu->GetHeader(i).GetSequenceNumber() == 2)
+                    {
+                        if (m_muTrafficPattern == WifiMuTrafficPattern::UL_MU)
+                        {
+                            NS_TEST_EXPECT_MSG_EQ(txVector.IsUlMu(),
+                                                  true,
+                                                  "MPDU " << **std::next(psdu->begin(), i)
+                                                          << " not transmitted in a TB PPDU");
+                        }
+                        else
+                        {
+                            NS_TEST_EXPECT_MSG_EQ(txVector.GetHeMuUserInfoMap().size(),
+                                                  2,
+                                                  "MPDU " << **std::next(psdu->begin(), i)
+                                                          << " not transmitted in a DL MU PPDU");
+                        }
+                    }
+                    // corrupt QoS data frame with sequence number equal to 3 (only once)
+                    if (psdu->GetHeader(i).GetSequenceNumber() != 3)
+                    {
+                        continue;
+                    }
+                    auto uid = psdu->GetPayload(i)->GetUid();
+                    if (!m_dataCorruptedSta)
+                    {
+                        m_uidList.push_front(uid);
+                        m_dataCorruptedSta = isDl ? psdu->GetAddr1() : psdu->GetAddr2();
+                        NS_LOG_INFO("CORRUPTED");
+                        m_errorModels.at(psdu->GetAddr1())->SetList(m_uidList);
+                    }
+                    else if ((isDl && m_dataCorruptedSta == psdu->GetAddr1()) ||
+                             (!isDl && m_dataCorruptedSta == psdu->GetAddr2()))
+                    {
+                        // do not corrupt the QoS data frame anymore
+                        if (auto it = std::find(m_uidList.cbegin(), m_uidList.cend(), uid);
+                            it != m_uidList.cend())
+                        {
+                            m_uidList.erase(it);
+                        }
+                        m_errorModels.at(psdu->GetAddr1())->SetList(m_uidList);
+                    }
+                    break;
+                }
+            }
+            break;
+        case WIFI_MAC_CTL_BACKRESP:
+            if (m_nMaxInflight > 1)
+            {
+                // we do not check the content of BlockAck when m_nMaxInflight is greater than 1
+                break;
+            }
+            CheckBlockAck(psdu, txVector, linkId);
+            m_blockAckCount++;
+            // to simulate a missed BlockAck, corrupt the fifth BlockAck frame (the first
+            // two BlockAck frames are sent to acknowledge the QoS data frames that triggered
+            // the establishment of Block Ack agreements)
+            if (m_blockAckCount == 5)
+            {
+                // corrupt the third BlockAck frame to simulate a missed BlockAck
+                m_uidList.push_front(psdu->GetPacket()->GetUid());
+                NS_LOG_INFO("CORRUPTED");
+                m_errorModels.at(psdu->GetAddr1())->SetList(m_uidList);
+            }
+            break;
+        case WIFI_MAC_CTL_TRIGGER:
+            psdu->GetPayload(0)->PeekHeader(trigger);
+            // the MU scheduler requests channel access on all links but we have to perform the
+            // following actions only once (hence why we only consider TF transmitted on link 0)
+            if (trigger.IsBasic() && m_waitFirstTf)
+            {
+                m_waitFirstTf = false;
+                // the AP is starting the transmission of the Basic Trigger frame, so generate
+                // the configured number of packets at STAs, which are sent in TB PPDUs
+                auto band = m_apMac->GetWifiPhy(linkId)->GetPhyBand();
+                Time txDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, band);
+                for (uint8_t i = 0; i < m_nStations; i++)
+                {
+                    Ptr<PacketSocketClient> client = CreateObject<PacketSocketClient>();
+                    client->SetAttribute("PacketSize", UintegerValue(450));
+                    client->SetAttribute("MaxPackets", UintegerValue(m_nPackets));
+                    client->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+                    client->SetAttribute("Priority", UintegerValue(i * 4)); // 0 and 4
+                    client->SetRemote(m_sockets[i]);
+                    m_staMacs[i]->GetDevice()->GetNode()->AddApplication(client);
+                    client->SetStartTime(txDuration);  // start when TX ends
+                    client->SetStopTime(Seconds(1.0)); // stop in a second
+                    client->Initialize();
+                }
+            }
+            break;
+        default:;
+        }
+    }
+
+    MultiLinkOperationsTestBase::Transmit(linkId, context, psduMap, txVector, txPowerW);
+}
+
+void
+MultiLinkMuTxTest::CheckBlockAck(Ptr<const WifiPsdu> psdu,
+                                 const WifiTxVector& txVector,
+                                 uint8_t linkId)
+{
+    /*
+     * Example sequence with DL_MU_BAR_BA_SEQUENCE
+     *                  ┌───────┬───────X
+     *           (To:1) │   2   │   3   │
+     *                  ├───────┼───────┤   ┌───┐             ┌───────┐
+     *  [link 0] (To:0) │   2   │   3   │   │BAR│      (To:1) │   3   │
+     *  ────────────────┴───────┴───────┴┬──┼───┼──┬──────────┴───────┴┬───┬────────
+     *                                   │BA│   │BA│                   │ACK│
+     *                                   └──┘   └──┘                   └───┘
+     *                              ┌───────┬───────┐
+     *                       (To:1) │   4   │   5   │
+     *                              ├───────┼───────┤        ┌───┐   ┌───┐
+     *  [link 1]             (To:0) │   4   │   5   │        │BAR│   │BAR│
+     *  ────────────────────────────┴───────┴───────┴┬──X────┴───┴┬──┼───┼──┬───────
+     *                                               │BA│         │BA│   │BA│
+     *                                               └──┘         └──┘   └──┘
+     *
+     * Example sequence with UL_MU
+     *
+     *           ┌──┐                     ┌────┐                      ┌───┐
+     *  [link 0] │TF│                     │M-BA│                      │ACK│
+     *  ─────────┴──┴──┬───────┬───────┬──┴────┴────────────┬───────┬─┴───┴─────────
+     *        (From:0) │   2   │   3   │           (From:1) │   3   │
+     *                 ├───────┼───────┤                    └───────┘
+     *        (From:1) │   2   │   3   │
+     *                 └───────┴───────X
+     *           ┌──┐
+     *  [link 1] │TF│
+     *  ─────────┴──┴──┬───────────────┬────────────────────────────────────────────
+     *        (From:0) │   QoS Null    │
+     *                 ├───────────────┤
+     *        (From:1) │   QoS Null    │
+     *                 └───────────────┘
+     */
+    auto mpdu = *psdu->begin();
+    CtrlBAckResponseHeader blockAck;
+    mpdu->GetPacket()->PeekHeader(blockAck);
+    bool isMpdu3corrupted;
+
+    switch (m_blockAckCount)
+    {
+    case 0:
+    case 1: // Ignore the first two BlockAck frames that acknowledged frames sent to establish BA
+        break;
+    case 2:
+        if (m_muTrafficPattern == WifiMuTrafficPattern::UL_MU)
+        {
+            NS_TEST_EXPECT_MSG_EQ(blockAck.IsMultiSta(), true, "Expected a Multi-STA BlockAck");
+            for (uint8_t i = 0; i < m_nStations; i++)
+            {
+                auto indices = blockAck.FindPerAidTidInfoWithAid(m_staMacs[i]->GetAssociationId());
+                NS_TEST_ASSERT_MSG_EQ(indices.size(), 1, "Expected one Per AID TID Info per STA");
+                auto index = indices.front();
+                NS_TEST_ASSERT_MSG_EQ(m_dataCorruptedSta.has_value(),
+                                      true,
+                                      "Expected that a QoS data frame was corrupted");
+                isMpdu3corrupted =
+                    m_staMacs[i]->GetLinkIdByAddress(*m_dataCorruptedSta).has_value();
+                NS_TEST_EXPECT_MSG_EQ(blockAck.IsPacketReceived(2, index),
+                                      true,
+                                      "MPDU 2 expected to be successfully received");
+                NS_TEST_EXPECT_MSG_EQ(blockAck.IsPacketReceived(3, index),
+                                      !isMpdu3corrupted,
+                                      "Unexpected reception status for MPDU 3");
+            }
+
+            break;
+        }
+    case 3:
+        // BlockAck frames in response to the first DL MU PPDU
+        isMpdu3corrupted = (mpdu->GetHeader().GetAddr2() == m_dataCorruptedSta);
+        NS_TEST_EXPECT_MSG_EQ(blockAck.IsPacketReceived(2),
+                              true,
+                              "MPDU 2 expected to be successfully received");
+        NS_TEST_EXPECT_MSG_EQ(blockAck.IsPacketReceived(3),
+                              !isMpdu3corrupted,
+                              "Unexpected reception status for MPDU 3");
+        // in case of DL MU, if there are at least two links setup, we expect all MPDUs to
+        // be inflight (on distinct links)
+        if (m_muTrafficPattern != WifiMuTrafficPattern::UL_MU &&
+            m_staMacs[0]->GetSetupLinkIds().size() > 1)
+        {
+            auto queue = m_apMac->GetTxopQueue(AC_BE);
+            Ptr<StaWifiMac> rcvMac;
+            if (m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress() ==
+                mpdu->GetHeader().GetAddr2())
+            {
+                rcvMac = m_staMacs[0];
+            }
+            else if (m_staMacs[1]->GetFrameExchangeManager(linkId)->GetAddress() ==
+                     mpdu->GetHeader().GetAddr2())
+            {
+                rcvMac = m_staMacs[1];
+            }
+            else
+            {
+                NS_ABORT_MSG("BlockAck frame not sent by a station in DL scenario");
+            }
+            auto item = queue->PeekByTidAndAddress(0, rcvMac->GetAddress());
+            std::size_t nQueuedPkt = 0;
+            auto delay = WifiPhy::CalculateTxDuration(psdu,
+                                                      txVector,
+                                                      rcvMac->GetWifiPhy(linkId)->GetPhyBand()) +
+                         MicroSeconds(1); // to account for propagation delay
+
+            while (item)
+            {
+                auto seqNo = item->GetHeader().GetSequenceNumber();
+                NS_TEST_EXPECT_MSG_EQ(item->IsInFlight(),
+                                      true,
+                                      "MPDU with seqNo=" << seqNo << " is not in flight");
+                auto linkIds = item->GetInFlightLinkIds();
+                NS_TEST_EXPECT_MSG_EQ(linkIds.size(),
+                                      1,
+                                      "MPDU with seqNo=" << seqNo
+                                                         << " is in flight on multiple links");
+                // The first two MPDUs are in flight on the same link on which the BlockAck
+                // is sent. The other two MPDUs (only for AP to STA/STA to AP scenarios) are
+                // in flight on a different link.
+                auto srcLinkId = m_apMac->GetLinkIdByAddress(mpdu->GetHeader().GetAddr1());
+                NS_TEST_ASSERT_MSG_EQ(srcLinkId.has_value(),
+                                      true,
+                                      "Addr1 of BlockAck is not an originator's link address");
+                NS_TEST_EXPECT_MSG_EQ((*linkIds.begin() == *srcLinkId),
+                                      (seqNo <= 3),
+                                      "MPDU with seqNo=" << seqNo
+                                                         << " in flight on unexpected link");
+                // check the Retry subfield and whether this MPDU is still queued
+                // after the originator has processed this BlockAck
+
+                // MPDUs acknowledged via this BlockAck are no longer queued
+                bool isQueued = (seqNo > (isMpdu3corrupted ? 2 : 3));
+                // The Retry subfield is set if the MPDU has not been acknowledged (i.e., it
+                // is still queued) and has been transmitted on the same link as the BlockAck
+                // (i.e., its sequence number is less than or equal to 2)
+                bool isRetry = isQueued && seqNo <= 3;
+
+                Simulator::Schedule(delay, [this, item, isQueued, isRetry]() {
+                    NS_TEST_EXPECT_MSG_EQ(item->IsQueued(),
+                                          isQueued,
+                                          "MPDU with seqNo="
+                                              << item->GetHeader().GetSequenceNumber() << " should "
+                                              << (isQueued ? "" : "not") << " be queued");
+                    NS_TEST_EXPECT_MSG_EQ(
+                        item->GetHeader().IsRetry(),
+                        isRetry,
+                        "Unexpected value for the Retry subfield of the MPDU with seqNo="
+                            << item->GetHeader().GetSequenceNumber());
+                });
+
+                nQueuedPkt++;
+                item = queue->PeekByTidAndAddress(0, rcvMac->GetAddress(), item);
+            }
+            // Each MPDU contains an A-MSDU consisting of two MSDUs
+            NS_TEST_EXPECT_MSG_EQ(nQueuedPkt, m_nPackets / 2, "Unexpected number of queued MPDUs");
+        }
+        break;
+    }
+}
+
+void
+MultiLinkMuTxTest::L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr)
+{
+    NS_LOG_INFO("Packet received by NODE " << +nodeId << "\n");
+    m_rxPkts[nodeId]++;
+}
+
+void
+MultiLinkMuTxTest::DoSetup()
+{
+    switch (m_muTrafficPattern)
+    {
+    case WifiMuTrafficPattern::DL_MU_BAR_BA_SEQUENCE:
+        Config::SetDefault("ns3::WifiDefaultAckManager::DlMuAckSequenceType",
+                           EnumValue(WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE));
+        break;
+    case WifiMuTrafficPattern::DL_MU_MU_BAR:
+        Config::SetDefault("ns3::WifiDefaultAckManager::DlMuAckSequenceType",
+                           EnumValue(WifiAcknowledgment::DL_MU_TF_MU_BAR));
+        break;
+    case WifiMuTrafficPattern::DL_MU_AGGR_MU_BAR:
+        Config::SetDefault("ns3::WifiDefaultAckManager::DlMuAckSequenceType",
+                           EnumValue(WifiAcknowledgment::DL_MU_AGGREGATE_TF));
+        break;
+    default:;
+    }
+
+    MultiLinkOperationsTestBase::DoSetup();
+
+    // Enable A-MSDU aggregation. Max A-MSDU size is set such that two MSDUs can be aggregated
+    for (auto mac : std::initializer_list<Ptr<WifiMac>>{m_apMac, m_staMacs[0], m_staMacs[1]})
+    {
+        mac->SetAttribute("BE_MaxAmsduSize", UintegerValue(1050));
+        mac->GetQosTxop(AC_BE)->SetAttribute("UseExplicitBarAfterMissedBlockAck",
+                                             BooleanValue(m_useBarAfterMissedBa));
+        mac->GetQosTxop(AC_BE)->SetAttribute("NMaxInflights", UintegerValue(m_nMaxInflight));
+
+        mac->SetAttribute("VI_MaxAmsduSize", UintegerValue(1050));
+        mac->GetQosTxop(AC_VI)->SetAttribute("UseExplicitBarAfterMissedBlockAck",
+                                             BooleanValue(m_useBarAfterMissedBa));
+        mac->GetQosTxop(AC_VI)->SetAttribute("NMaxInflights", UintegerValue(m_nMaxInflight));
+    }
+
+    // aggregate MU scheduler
+    auto muScheduler = CreateObjectWithAttributes<RrMultiUserScheduler>(
+        "EnableUlOfdma",
+        BooleanValue(m_muTrafficPattern == WifiMuTrafficPattern::UL_MU),
+        "EnableBsrp",
+        BooleanValue(false),
+        "UlPsduSize",
+        UintegerValue(2000));
+    m_apMac->AggregateObject(muScheduler);
+
+    // install post reception error model on all devices
+    for (std::size_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
+    {
+        auto errorModel = CreateObject<ListErrorModel>();
+        m_errorModels[m_apMac->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
+        m_apMac->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+    }
+    for (std::size_t linkId = 0; linkId < m_staMacs[0]->GetNLinks(); linkId++)
+    {
+        auto errorModel = CreateObject<ListErrorModel>();
+        m_errorModels[m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
+        m_staMacs[0]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+
+        errorModel = CreateObject<ListErrorModel>();
+        m_errorModels[m_staMacs[1]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
+        m_staMacs[1]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+    }
+}
+
+void
+MultiLinkMuTxTest::StartTraffic()
+{
+    const Time duration = Seconds(1);
+    Address destAddr;
+
+    PacketSocketHelper packetSocket;
+    packetSocket.Install(m_apMac->GetDevice()->GetNode());
+    packetSocket.Install(m_staMacs[0]->GetDevice()->GetNode());
+    packetSocket.Install(m_staMacs[1]->GetDevice()->GetNode());
+
+    if (m_muTrafficPattern < WifiMuTrafficPattern::UL_MU)
+    {
+        // DL Traffic
+        for (uint8_t i = 0; i < m_nStations; i++)
+        {
+            PacketSocketAddress socket;
+            socket.SetSingleDevice(m_apMac->GetDevice()->GetIfIndex());
+            socket.SetPhysicalAddress(m_staMacs[i]->GetDevice()->GetAddress());
+            socket.SetProtocol(1);
+
+            // the first client application generates three packets in order
+            // to trigger the establishment of a Block Ack agreement
+            auto client1 = CreateObject<PacketSocketClient>();
+            client1->SetAttribute("PacketSize", UintegerValue(450));
+            client1->SetAttribute("MaxPackets", UintegerValue(3));
+            client1->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+            client1->SetRemote(socket);
+            m_apMac->GetDevice()->GetNode()->AddApplication(client1);
+            client1->SetStartTime(i * MilliSeconds(50));
+            client1->SetStopTime(duration);
+
+            // the second client application generates the first half of the selected number
+            // of packets, which are sent in DL MU PPDUs.
+            auto client2 = CreateObject<PacketSocketClient>();
+            client2->SetAttribute("PacketSize", UintegerValue(450));
+            client2->SetAttribute("MaxPackets", UintegerValue(m_nPackets / 2));
+            client2->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+            client2->SetRemote(socket);
+            m_apMac->GetDevice()->GetNode()->AddApplication(client2);
+            // start after all BA agreements are established
+            client2->SetStartTime(m_nStations * MilliSeconds(50));
+            client2->SetStopTime(duration);
+
+            // the third client application generates the second half of the selected number
+            // of packets, which are sent in DL MU PPDUs.
+            auto client3 = CreateObject<PacketSocketClient>();
+            client3->SetAttribute("PacketSize", UintegerValue(450));
+            client3->SetAttribute("MaxPackets", UintegerValue(m_nPackets / 2));
+            client3->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+            client3->SetRemote(socket);
+            m_apMac->GetDevice()->GetNode()->AddApplication(client3);
+            // start during transmission of first A-MPDU, if multiple links are setup
+            client3->SetStartTime(m_nStations * MilliSeconds(50) + MilliSeconds(3));
+            client3->SetStopTime(duration);
+        }
+    }
+    else
+    {
+        // UL Traffic
+        for (uint8_t i = 0; i < m_nStations; i++)
+        {
+            m_sockets[i].SetSingleDevice(m_staMacs[i]->GetDevice()->GetIfIndex());
+            m_sockets[i].SetPhysicalAddress(m_apMac->GetDevice()->GetAddress());
+            m_sockets[i].SetProtocol(1);
+
+            // the first client application generates three packets in order
+            // to trigger the establishment of a Block Ack agreement
+            Ptr<PacketSocketClient> client1 = CreateObject<PacketSocketClient>();
+            client1->SetAttribute("PacketSize", UintegerValue(450));
+            client1->SetAttribute("MaxPackets", UintegerValue(3));
+            client1->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+            client1->SetAttribute("Priority", UintegerValue(i * 4)); // 0 and 4
+            client1->SetRemote(m_sockets[i]);
+            m_staMacs[i]->GetDevice()->GetNode()->AddApplication(client1);
+            client1->SetStartTime(i * MilliSeconds(50));
+            client1->SetStopTime(duration);
+
+            // packets to be included in TB PPDUs are generated (by Transmit()) when
+            // the first Basic Trigger Frame is sent by the AP
+        }
+
+        // MU scheduler starts requesting channel access when we are done with BA agreements
+        Simulator::Schedule(m_nStations * MilliSeconds(50), [this]() {
+            auto muScheduler = m_apMac->GetObject<MultiUserScheduler>();
+            NS_TEST_ASSERT_MSG_NE(muScheduler, nullptr, "Expected an aggregated MU scheduler");
+            muScheduler->SetAccessReqInterval(MilliSeconds(3));
+            // channel access is requested only once
+            muScheduler->SetAccessReqInterval(Seconds(0));
+        });
+    }
+
+    // install a server on all nodes and connect traced callback
+    for (auto nodeIt = NodeList::Begin(); nodeIt != NodeList::End(); nodeIt++)
+    {
+        PacketSocketAddress srvAddr;
+        auto device = DynamicCast<WifiNetDevice>((*nodeIt)->GetDevice(0));
+        NS_TEST_ASSERT_MSG_NE(device, nullptr, "Expected a WifiNetDevice");
+        srvAddr.SetSingleDevice(device->GetIfIndex());
+        srvAddr.SetProtocol(1);
+
+        Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
+        server->SetLocal(srvAddr);
+        (*nodeIt)->AddApplication(server);
+        server->SetStartTime(Seconds(0)); // now
+        server->SetStopTime(duration);
+        server->TraceConnectWithoutContext(
+            "Rx",
+            MakeCallback(&MultiLinkMuTxTest::L7Receive, this).Bind(device->GetNode()->GetId()));
+    }
+
+    Simulator::Stop(duration);
+}
+
+void
+MultiLinkMuTxTest::DoRun()
+{
+    Simulator::Run();
+
+    // Expected number of packets received by each node (AP, STA 0, STA 1) at application layer
+    std::array<std::size_t, 3> expectedRxPkts{};
+
+    switch (m_muTrafficPattern)
+    {
+    case WifiMuTrafficPattern::DL_MU_BAR_BA_SEQUENCE:
+    case WifiMuTrafficPattern::DL_MU_MU_BAR:
+    case WifiMuTrafficPattern::DL_MU_AGGR_MU_BAR:
+        // both STA 0 and STA 1 receive m_nPackets + 3 (sent to trigger BA establishment) packets
+        expectedRxPkts[1] = m_nPackets + 3;
+        expectedRxPkts[2] = m_nPackets + 3;
+        break;
+    case WifiMuTrafficPattern::UL_MU:
+        // AP receives m_nPackets + 3 (sent to trigger BA establishment) packets from each station
+        expectedRxPkts[0] = 2 * (m_nPackets + 3);
+        break;
+    }
+
+    NS_TEST_EXPECT_MSG_EQ(+m_rxPkts[0],
+                          +expectedRxPkts[0],
+                          "Unexpected number of packets received by the AP");
+    NS_TEST_EXPECT_MSG_EQ(+m_rxPkts[1],
+                          +expectedRxPkts[1],
+                          "Unexpected number of packets received by STA 0");
+    NS_TEST_EXPECT_MSG_EQ(+m_rxPkts[2],
+                          +expectedRxPkts[2],
+                          "Unexpected number of packets received by STA 1");
+
+    // check that setting the QosTxop::NMaxInflights attribute has the expected effect.
+    // For DL, for each station we send 2 MPDUs to trigger BA agreement and m_nPackets / 2 MPDUs
+    // For UL, each station sends 2 MPDUs to trigger BA agreement and m_nPackets / 2 MPDUs
+    NS_TEST_EXPECT_MSG_EQ(
+        m_inflightCount.size(),
+        2 * (2 + m_nPackets / 2),
+        "Did not collect number of simultaneous transmissions for all data frames");
+
+    auto nMaxInflight = std::min(m_nMaxInflight, m_staMacs[0]->GetSetupLinkIds().size());
+    std::size_t maxCount = 0;
+    for (const auto& [txSeqNoPair, count] : m_inflightCount)
+    {
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(count,
+                                    nMaxInflight,
+                                    "MPDU with seqNo="
+                                        << txSeqNoPair.second
+                                        << " transmitted simultaneously more times than allowed");
+        maxCount = std::max(maxCount, count);
+    }
+
+    NS_TEST_EXPECT_MSG_EQ(
+        maxCount,
+        nMaxInflight,
+        "Expected that at least one data frame was transmitted simultaneously a number of "
+        "times equal to the NMaxInflights attribute");
+
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Test release of sequence numbers upon CTS timeout in multi-link operations
+ *
+ * In this test, an AP MLD and a non-AP MLD setup 3 links. Usage of RTS/CTS protection is
+ * enabled for frames whose length is at least 1000 bytes. The AP MLD receives a first set
+ * of 4 packets from the upper layer and sends an RTS frame, which is corrupted at the
+ * receiver, on a first link. When the RTS frame is transmitted, the AP MLD receives another
+ * set of 4 packets, which are transmitted after a successful RTS/CTS exchange on a second
+ * link. In the meantime, a new RTS/CTS exchange is successfully carried out (on the first
+ * link or on the third link) to transmit the first set of 4 packets. When the transmission
+ * of the first set of 4 packets starts, the AP MLD receives the third set of 4 packets from
+ * the upper layer, which are transmitted after a successful RTS/CTS exchange.
+ *
+ * This test checks that sequence numbers are correctly assigned to all the MPDUs carrying data.
+ */
+class ReleaseSeqNoAfterCtsTimeoutTest : public MultiLinkOperationsTestBase
+{
+  public:
+    ReleaseSeqNoAfterCtsTimeoutTest();
+    ~ReleaseSeqNoAfterCtsTimeoutTest() override = default;
+
+  protected:
+    void DoSetup() override;
+    void DoRun() override;
+    void Transmit(uint8_t linkId,
+                  std::string context,
+                  WifiConstPsduMap psduMap,
+                  WifiTxVector txVector,
+                  double txPowerW) override;
+
+  private:
+    void StartTraffic() override;
+
+    /**
+     * \return the client application generating 4 packets addressed to the non-AP MLD
+     */
+    Ptr<PacketSocketClient> GetApplication() const;
+
+    PacketSocketAddress m_socket;     //!< packet socket address
+    std::size_t m_nQosDataFrames;     //!< counter for transmitted QoS data frames
+    Ptr<ListErrorModel> m_errorModel; //!< error rate model to corrupt first RTS frame
+    bool m_rtsCorrupted;              //!< whether the first RTS frame has been corrupted
+};
+
+ReleaseSeqNoAfterCtsTimeoutTest::ReleaseSeqNoAfterCtsTimeoutTest()
+    : MultiLinkOperationsTestBase(
+          "Check sequence numbers after CTS timeout",
+          1,
+          {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+          {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"}),
+      m_nQosDataFrames(0),
+      m_errorModel(CreateObject<ListErrorModel>()),
+      m_rtsCorrupted(false)
+{
+}
+
+void
+ReleaseSeqNoAfterCtsTimeoutTest::DoSetup()
+{
+    // Enable RTS/CTS
+    Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsThreshold", StringValue("1000"));
+
+    MultiLinkOperationsTestBase::DoSetup();
+
+    // install post reception error model on all STAs affiliated with non-AP MLD
+    for (std::size_t linkId = 0; linkId < m_staMacs[0]->GetNLinks(); linkId++)
+    {
+        m_staMacs[0]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(m_errorModel);
+    }
+}
+
+Ptr<PacketSocketClient>
+ReleaseSeqNoAfterCtsTimeoutTest::GetApplication() const
+{
+    const Time duration = Seconds(1);
+
+    auto client = CreateObject<PacketSocketClient>();
+    client->SetAttribute("PacketSize", UintegerValue(1000));
+    client->SetAttribute("MaxPackets", UintegerValue(4));
+    client->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+    client->SetRemote(m_socket);
+    client->SetStartTime(Seconds(0)); // now
+    client->SetStopTime(duration);
+
+    return client;
+}
+
+void
+ReleaseSeqNoAfterCtsTimeoutTest::StartTraffic()
+{
+    const Time duration = Seconds(1);
+
+    PacketSocketHelper packetSocket;
+    packetSocket.Install(m_apMac->GetDevice()->GetNode());
+    packetSocket.Install(m_staMacs[0]->GetDevice()->GetNode());
+
+    m_socket.SetSingleDevice(m_apMac->GetDevice()->GetIfIndex());
+    m_socket.SetPhysicalAddress(m_staMacs[0]->GetAddress());
+    m_socket.SetProtocol(1);
+
+    // install client application generating 4 packets
+    m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication());
+
+    // install a server on all nodes
+    for (auto nodeIt = NodeList::Begin(); nodeIt != NodeList::End(); nodeIt++)
+    {
+        Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
+        server->SetLocal(m_socket);
+        (*nodeIt)->AddApplication(server);
+        server->SetStartTime(Seconds(0)); // now
+        server->SetStopTime(duration);
+    }
+}
+
+void
+ReleaseSeqNoAfterCtsTimeoutTest::Transmit(uint8_t linkId,
+                                          std::string context,
+                                          WifiConstPsduMap psduMap,
+                                          WifiTxVector txVector,
+                                          double txPowerW)
+{
+    auto psdu = psduMap.begin()->second;
+
+    if (psdu->GetHeader(0).IsRts() && !m_rtsCorrupted)
+    {
+        m_errorModel->SetList({psdu->GetPacket()->GetUid()});
+        m_rtsCorrupted = true;
+        // generate other packets when the first RTS is transmitted
+        m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication());
+    }
+    else if (psdu->GetHeader(0).IsQosData())
+    {
+        m_nQosDataFrames++;
+
+        if (m_nQosDataFrames == 2)
+        {
+            // generate other packets when the second QoS data frame is transmitted
+            m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication());
+        }
+    }
+
+    MultiLinkOperationsTestBase::Transmit(linkId, context, psduMap, txVector, txPowerW);
+}
+
+void
+ReleaseSeqNoAfterCtsTimeoutTest::DoRun()
+{
+    Simulator::Stop(Seconds(1.0));
+    Simulator::Run();
+
+    NS_TEST_EXPECT_MSG_EQ(m_nQosDataFrames, 3, "Unexpected number of transmitted QoS data frames");
+
+    std::size_t count{};
+
+    for (const auto& txPsdu : m_txPsdus)
+    {
+        auto psdu = txPsdu.psduMap.begin()->second;
+
+        if (!psdu->GetHeader(0).IsQosData())
         {
-            // STA had to switch PHY band to match AP's operating band. Given that we
-            // are using three distinct spectrum channels (one per band), a STA will
-            // not receive Beacon frames after switching PHY band. After a number of
-            // missed Beacon frames, the link is disabled
-            NS_TEST_EXPECT_MSG_EQ(m_staMac->GetWifiPhy(linkId)->GetState()->IsStateOff(),
-                                  true,
-                                  "Expecting link " << +linkId
-                                                    << " to be disabled due to switching PHY band");
             continue;
         }
 
-        // the link has been setup and must be active
-        NS_TEST_EXPECT_MSG_EQ(m_staMac->GetWifiPhy(linkId)->GetState()->IsStateOff(),
-                              false,
-                              "Expecting link " << +linkId << " to be active");
+        NS_TEST_EXPECT_MSG_EQ(psdu->GetNMpdus(), 4, "Unexpected number of MPDUs in A-MPDU");
+
+        count++;
+        uint16_t expectedSeqNo{};
+
+        switch (count)
+        {
+        case 1:
+            expectedSeqNo = 4;
+            break;
+        case 2:
+            expectedSeqNo = 0;
+            break;
+        case 3:
+            expectedSeqNo = 8;
+            break;
+        }
+
+        for (const auto& mpdu : *PeekPointer(psdu))
+        {
+            NS_TEST_EXPECT_MSG_EQ(mpdu->GetHeader().GetSequenceNumber(),
+                                  expectedSeqNo++,
+                                  "Unexpected sequence number");
+        }
     }
+
+    Simulator::Destroy();
 }
 
 /**
